<?php
/*
Plugin Name: ploppy
Plugin URI: http://www.fatsquirrel.org/software/ploppy/
Description: Let the Blogosphere know how well your bowels are doing.
Version: 0.9
Author: Veghead
Author URI: http://www.fatsquirrel.org/bologs/veghead/

$Id: ploppy.php 18 2006-11-18 22:30:05Z veg $

Copyright 2006  Veghead ( wpplugin@fatsquirrel.org )

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

define( 'VEG_PLOP_ICON_EXT', 'png' );
define( 'VEG_PLOP_REL_PATH', "/wp-content/plugins/ploppy" );
define( 'VEG_PLOP_ICON_PATH', get_settings('siteurl') . VEG_PLOP_REL_PATH );
define( 'VEG_PLOP_VAL', 'ploppyval' );

// The Bristol Stool Scale as an array
$veg_plop_types = array(
    0 => 'Nothing (constipated)',
    1 => 'Separate hard lumps, like nuts (hard to pass)',
    2 => 'Sausage-shaped, but lumpy',
    3 => 'Like a sausage but with cracks on its surface',
    4 => 'Like a sausage or snake, smooth and soft',
    5 => 'Soft blobs with clear cut edges (passed easily)',
    6 => 'Fluffy pieces with ragged edges, mushy',
    7 => 'Watery, no solid pieces (entirely liquid)',
    8 => 'No Comment');

add_filter( 'simple_edit_form', 'veg_plop_wform' );
add_filter( 'edit_form_advanced', 'veg_plop_wform' );
add_filter( 'edit_page_form', 'veg_plop_wform' );
add_action( 'edit_post', 'veg_plop_update' );
add_action( 'publish_post', 'veg_plop_update' );
add_action( 'save_post', 'veg_plop_update' );
add_filter( 'the_content', 'showploppy' );


/**
 *  Generate poo pull-down for edit forms
 */
function veg_plop_wform(  ) 
{
	global $post, $postdata, $content, $veg_plop_types;
	$id = isset( $post ) ? $post->ID : $postdata->ID;
	$ploppyval = get_post_meta( $id, VEG_PLOP_VAL, true );
	if ( ! $ploppyval ) $ploppyval = 8;
	?>
	<fieldset id="ploppyfields">
		<legend>How are your poos ?</legend>
		<div>
		<select name="veg_plop_val">
	<?php
	for ( $i = 0 ; $i <= 8 ; $i++ ) {

		$sel = ( ($ploppyval - 1) == $i ) ? 'selected="selected"' : '' ;
		echo( '<option value="' . ($i + 1) . '" ' . $sel . '>Type ' . $i );
		echo( ' - ' . $veg_plop_types[$i] . '</option>' );
	}
	?>
		</select>
		</div>
	</fieldset>
	<?php
}


/**
 * Update value in edit/update/post 
 */
function veg_plop_update( $id ) 
{
	delete_post_meta( $id, VEG_PLOP_VAL );
	$ploppyval = $_REQUEST['veg_plop_val'];
	if ( !empty( $ploppyval ) ) {
		add_post_meta( $id, VEG_PLOP_VAL, $ploppyval );
	}
}


/**
 * Filter that display the poo status.
 */
function showploppy( $orig ) 
{
	global $post, $veg_plop_types;
	$ploppyval = get_post_meta( $post->ID, VEG_PLOP_VAL, TRUE );
	if (( empty( $ploppyval ) ) || ( $ploppyval == 9 )) {
		return( $orig );
	}

	// Stored value is one greater than the real Bristol value.
	// This is to avoid trying to store zero.
	$ploppyval--;

	$img = sprintf( '<img src="%s/%d.%s" border="0" align="middle" alt="-" />',
											VEG_PLOP_ICON_PATH, $ploppyval, 
											VEG_PLOP_ICON_EXT);
	$full = sprintf( '%s<p class="ploppy">Stools: Type %d %s %s</p>',
											$orig, $ploppyval, $img,
											$veg_plop_types[$ploppyval]);
	return( $full );
}
?>
